-- Add modified property and extensions phonebook
alter table `ombutel`.`ombu_phonebooks`
	add column `modified` datetime not null default '0000-00-00';
insert into `ombutel`.`ombu_phonebooks` (`description`, `show_in_portal`) values ('', 'yes');
update `ombutel`.`ombu_phonebooks` set `phonebook_id` = 0 where `description` = '';
update `ombutel`.`ombu_phonebooks` set `modified` = now();

-- Reorganize contacts table
alter table `ombutel`.`ombu_contacts`
	add column `phonebook_id` int unsigned not null default 0 after `contact_id`,
	change column `second_name` `second_name` varchar(255) default null after `first_name`,
	change column `last_name` `last_name` varchar(255) default null after `second_name`,
	change column `suffix` `suffix` varchar(255) default null after `last_name`,
	change column `department` `job_title` varchar(255) default null after `organization`,
	change column `mobile` `mobile` varchar(255) default null after `notes`,
	change column `phone1` `alt_phone` varchar(255) default null after `notes`,
	change column `phone` `phone` varchar(255) default null after `notes`,
	change column `email` `email` varchar(255) default null after `fax`,
	drop column `account_id`,
	drop column `subscribe_to`,
	add foreign key (`phonebook_id`) references `ombutel`.`ombu_phonebooks`(`phonebook_id`) on delete cascade;

-- Move phonebook contacts to contacts table
insert into `ombutel`.`ombu_contacts` (`phonebook_id`, `first_name`,
	`second_name`, `last_name`, `organization`, `job_title`, `phone`,
	`alt_phone`, `mobile`, `fax`, `email`)
select
	`phonebook_id`,
	`first_name`,
	`second_name`,
	`last_name`,
	`organization`,
	`job_title`,
	`phone`,
	`phone1`,
	`mobile`,
	`fax`,
	`email`
from `ombutel`.`ombu_phonebook_contacts`;

-- Remove orphaned extension contacts
delete from `ombutel`.`ombu_contacts`
where `extension_id` is not null
	and `extension_id` not in (select `extension_id` from `ombutel`.`ombu_extensions`);

-- Drop old phonebook contacts
drop table `ombutel`.`ombu_phonebook_contacts`;

-- Populate extension contacts
insert into `ombutel`.`ombu_contacts` (`extension_id`, `phonebook_id`,
`first_name`, `last_name`, `second_name`, `phone`, `email`)
select
	e.`extension_id`,
	0,
	coalesce(c.`first_name`, @first := substring_index(e.`name`, ' ', 1)),
	coalesce(c.`last_name`, if ((@last := substring_index(e.`name`, ' ', -1)) != @first, @last, null)),
	coalesce(c.`second_name`, if((@second := trim(substring(e.`name`, length(@first) + 2, length(e.`name`) - length(@first) - length(@last) - 2))) != '', @second, null)),
	coalesce(c.`phone`, e.`extension`) as `phone`,
	coalesce(c.`email`, e.`email`) as `email`
from `ombutel`.`ombu_extensions` e
left join `ombutel`.`ombu_contacts` c using (`extension_id`)
where c.`extension_id` is null;
