$(function(){
   jQuery.validator.addMethod('IPv4CIDR',function(value, element){
       return this.optional(element) || /^(([01]?\d?\d|2[0-4]\d|25[0-5])\.){3}([01]?\d?\d|2[0-4]\d|25[0-5])\/(\d{1}|[0-2]{1}\d{1}|3[0-2])$/.test(value);
   }, "Please enter a valid IPv4 CIDR (0.0.0.0/24)");

   jQuery.validator.addMethod('extensionNumber', function(value, element){
       return this.optional(element) || /^[0-9#*+]+$/.test(value);
   }, "Please enter a valid extension number. *,#,+ and numbers are allowed");

   jQuery.validator.addMethod('phonePassword', function(value, element){
       return this.optional(element) || /^[0-9*]+$/.test(value);
   }, "Please enter a valid phone password. * and numbers are allowed");

    jQuery.validator.addMethod('cid', function(value, element){
        return this.optional(element) || /^(".*?")(\s)(<[0-9\s*#+()-]+>)$/.test(value);
    }, "Please enter a valid Caller ID ( ex. \"CID Name\" <(234) 123-4567> )");

    jQuery.validator.addMethod('context', function(value, element){
        return this.optional(element) || /^[A-Z0-9a-z_\-+*#]+$/.test(value);
    }, "Please enter a valid context string. Alphanumeric value with dash and underscore are allowed");

    jQuery.validator.addMethod('asterisk_pattern', function(value, element){
        return this.optional(element) || /^[A-Z0-9a-z-!.#*+\[\]]+$/.test(value);
    }, "Please enter a valid asterisk pattern");
});
